#include "midiin.h"

int midiin_init(XUartNs550* InstancePtr, u16 DeviceId) {
	XUartNs550_Initialize(InstancePtr, DeviceId);
	
	XUartNs550Format* MIDI_format;
	MIDI_format->BaudRate = 31250;
	MIDI_format->DataBits = XUN_FORMAT_8_BITS;
	MIDI_format->Parity = XUN_FORMAT_NO_PARITY;
	MIDI_format->StopBits = XUN_FORMAT_1_STOP_BIT;
	int Status = XUartNs550_SetDataFormat(InstancePtr, MIDI_format);
	
	XUartNs550_SetHandler(InstancePtr, (XUartNs550_Handler)midiin_int_handler, InstancePtr);
	
	XUartNs550_SetOptions(InstancePtr, XUN_OPTION_DATA_INTR | XUN_OPTION_FIFOS_ENABLE);
	
	XUartNs550_SetFifoThreshold (InstancePtr, XUN_FIFO_TRIGGER_01);
	
	MidiReadItr = 0;
	MidiWriteItr = 0;
	
	
	/* Start listening */ 
	XUartNs550_Recv(InstancePtr, RecvMidiBuffer, 1);
	
	return Status;
}

void midiin_int_handler(void *CallBackRef, u32 Event, unsigned int EventData) {
	if (Event == XUN_EVENT_RECV_DATA) {
		XUartNs550_Recv(CallBackRef, &RecvMidiBuffer[++MidiWriteItr], 1);
	} else if (Event == XUN_EVENT_RECV_TIMEOUT | Event ==  XUN_EVENT_RECV_ERROR) {
		XUartNs550_Recv(CallBackRef, &RecvMidiBuffer[MidiWriteItr], 1);
	}
}
