#ifndef USB_DECODER_H_
#define USB_DECODER_H_

#include "usbio.h"

volatile u8 eventID;
volatile u8 typeID;
volatile u8 recvValue[4];

void decodeUsb();

enum usbEventIDs {
	NOTE_EVENT = 0,
	OP1_PARAM,
	OP2_PARAM,
	OP3_PARAM,
	OP4_PARAM,
	OP5_PARAM,
	OP6_PARAM,
	GLOBAL_PARAM,
};

enum noteType {
	N_OFF = 0x80,
	N_ON = 0x90
};
enum usbParamTypes {
	GLB_VOL = 0,
	GLB_PAN,
	GLB_ALG,
	GLB_FBK,
	GLB_LFO_WAV,
	GLB_LFO_SPD,
	GLB_LFO_DEL,
	GLB_LFO_SYNC,
	GLB_LFO_PITCH,
	GLB_OSC_SYNC,
	GLB_PEG_R1,
	GLB_PEG_L1,
	GLB_PEG_R2,
	GLB_PEG_L2,
	GLB_PEG_R3,
	GLB_PEG_L3,
	GLB_PEG_R4,
	GLB_PEG_L4,
	GLB_TRANS,
	OP_VOL,
	OP_ACT,
	OP_LFO_AMS,
	OP_OSC_MODE,
   OP_OSC_RATIO_COARSE,
   OP_OSC_RATIO_FINE,
   OP_OSC_FIXED_FREQ,
	OP_EG_R1,
	OP_EG_L1,
	OP_EG_R2,
	OP_EG_L2,
	OP_EG_R3,
	OP_EG_L3,
	OP_EG_R4,
	OP_EG_L4,
	OP_KBD_RS,
	OP_KDB_VS
};

#endif
