#include "usbio.h"


int usbio_init(XUartNs550* InstancePtr, u16 DeviceId) {
	XUartNs550_Initialize(InstancePtr, DeviceId);
	
	XUartNs550Format* USB_format;
	USB_format->BaudRate = 1562500;
	USB_format->DataBits = XUN_FORMAT_8_BITS;
	USB_format->Parity = XUN_FORMAT_NO_PARITY;
	USB_format->StopBits = XUN_FORMAT_1_STOP_BIT;
	int Status =  XUartNs550_SetDataFormat(InstancePtr, USB_format);
	
	XUartNs550_SetHandler(InstancePtr, (XUartNs550_Handler)usbin_int_handler, InstancePtr);
	
	XUartNs550_SetOptions(InstancePtr, XUN_OPTION_DATA_INTR | XUN_OPTION_FIFOS_ENABLE);
	
	usbInReadItr = 0;
	usbInWriteItr = 0;
	
	/* not used
	usbOutReadItr = 0;
	usbOutWriteItr = 0;
	outgoingUsb = 0;
	*/
	
	/* Start listening */
	XUartNs550_Recv(InstancePtr, RecvUsbBuffer[usbInWriteItr].data, RECV_SIZE);
	
	return Status;
}

void usbin_int_handler(void *CallBackRef, u32 Event, unsigned int EventData) {
	if (Event == XUN_EVENT_RECV_DATA) {
		usbInWriteItr = incIt(usbInWriteItr);
		XUartNs550_Recv(CallBackRef, RecvUsbBuffer[usbInWriteItr].data, RECV_SIZE);
	} else if (Event == XUN_EVENT_RECV_TIMEOUT | Event == XUN_EVENT_RECV_ERROR) {
		XUartNs550_Recv(CallBackRef, RecvUsbBuffer[usbInWriteItr].data, RECV_SIZE);
	}
}

/* not used
void sendUSB(XUartNs550* InstancePtr) {
	if (!XUartNs550_IsSending(InstancePtr)) {
		XUartNs550_Send(InstancePtr, SendUsbBuffer[usbOutReadItr].data, SendUsbBuffer[usbOutReadItr].length);
		++usbOutReadItr;
		--outgoingUsb;
	}
}

void sendUSBData(u8* data, int length) {
	SendUsbBuffer[usbOutWriteItr].data = data;
	SendUsbBuffer[usbOutWriteItr].length = length;
	++usbOutWriteItr;
	++outgoingUsb;
}
*/
