----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    20:49:11 09/07/2011 
-- Design Name: 
-- Module Name:    components - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity data_reg is
  generic(
    width : integer
  );
  port(
    clk, rst : in std_logic;
    d : in std_logic_vector(width-1 downto 0);
    q : out std_logic_vector(width-1 downto 0);
    wen : in std_logic
  );
end data_reg;

architecture behavior of data_reg is
	signal q_out, q_next : std_logic_vector(width-1 downto 0);
begin

q <= q_out;

comb : process(d,wen,q_out,rst)
begin
	if(rst = '1') then
		q_next <= (others=>'0');
	else
		q_next <= q_out;
		if(wen = '1') then
			q_next <= d;
		end if;
	end if;
end process;
 
sync : process(clk)
begin
	if(clk'event and clk = '1') then
		q_out <= q_next;
	end if;
end process;
end behavior;


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
	
entity bit_dff is
	port(
		clk : in std_logic;
		rst : in std_logic;
		d : in std_logic;
		q : out std_logic
	);
end bit_dff;
  
architecture implementation of bit_dff is
begin

synchronous : process(clk)
begin
	if(clk'event and clk = '1') then
		if(rst = '1') then
			q <= '0';
		else
			q <= d;
		end if;
	end if;
end process;
end implementation;

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
	
entity dff is
	generic(
		width : integer
	);
	port(
		clk : in std_logic;
		rst : in std_logic;
		d : in std_logic_vector(width-1 downto 0);
		q : out std_logic_vector(width-1 downto 0)
	);
end dff;
  
architecture implementation of dff is
begin

synchronous : process(clk)
begin
	if(clk'event and clk = '1') then
		if(rst = '1') then
			q <= (others=>'0');
		else
			q <= d;
		end if;
	end if;
end process;
end implementation;

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all;

entity stupidpacc is
	generic(
		width : integer
	);
	port(
		clk,rst : in std_logic;
		pinc : in std_logic_vector(width-1 downto 0);
		pout : out std_logic_vector(width-1 downto 0)
	);
end stupidpacc;
	
architecture implementation of stupidpacc is
	signal phase,phase_next : std_logic_vector(width-1 downto 0);
begin
	pout <= phase;

comb : process(pinc,phase)
begin
	phase_next <= phase + pinc;
end process;

synchronous : process(clk)
begin
	if(clk'event and clk = '1') then
		if(rst = '1') then
			phase <= (others=>'0');
		else
			phase <= phase_next;
		end if;
	end if;
end process;

end;