--
--	Package File Template
--
--	Purpose: This package defines supplemental types, subtypes, 
--		 constants, and functions 
--
--   To use any of the example code shown below, uncomment the lines and modify as necessary
--

library IEEE;
use IEEE.STD_LOGIC_1164.all;

package types is

   constant LRMULT : integer := 512;

	component bit_dff
		port(
			clk : in std_logic;
			rst : in std_logic;
			d : in std_logic;
			q : out std_logic
		);
	end component; 
 
	component data_reg
		generic(
			width : integer
		);
		port(
			clk, rst : in std_logic;
			d : in std_logic_vector(width-1 downto 0);
			q : out std_logic_vector(width-1 downto 0);
			wen : in std_logic
		);
	 end component;    

	component dff is
		generic(
			width : integer
		);
		port(
			clk : in std_logic;
			rst : in std_logic;
			d : in std_logic_vector(width-1 downto 0);
			q : out std_logic_vector(width-1 downto 0)
		);
	end component dff;

	component stupidpacc is
	generic(
		width : integer
	);
	port(
		clk,rst : in std_logic;
		pinc : in std_logic_vector(width-1 downto 0);
		pout : out std_logic_vector(width-1 downto 0)
	);
	end component;


END types;
